---
layout: docs
toc_group: reference-manual
link_title: Languages References
permalink: /reference-manual/languages/
---

# Languages References

GraalVM is designed to accelerate the execution of applications written in Java and other JVM languages while also providing a high-performance runtime for JavaScript, Ruby, Python, and a number of other popular languages.
GraalVM's polyglot capabilities make it possible to mix multiple programming languages in a single application while eliminating any foreign language call costs.

If you are mostly interested in GraalVM's support for a specific language, here you can find the most extensive documentation:
* [Java](java/README.md)
* [Java on Truffle](java-on-truffle/README.md)
* [JavaScript and Node.js](https://github.com/oracle/graaljs/blob/master/docs/user/README.md)
* [LLVM Languages](llvm/README.md)
* [Python](https://github.com/oracle/graalpython/blob/master/docs/user/README.md)
* [R](https://github.com/oracle/fastr/blob/master/documentation/user/README.md)
* [Ruby](https://github.com/oracle/truffleruby/blob/master/README.md)
* [WebAssembly](wasm/README.md)
